--[[################################################################################
    # File      : /hook/lua/ui/dialogs/ConsolePlus.lua                             #
    # Author    : Manimal                                                          #
    # Version   : 25 septembre 2008                                                #
    # Revision  : 18 mars 2009                                                     #
    #                                                                              #
    # Summary   : Console that brings some new features                            #
    # Copyright : CopyLeft Manimal.                                                #
    ################################################################################]]--


# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# NOTE :
# ======
# tablir 1 Liste de RGLES propres aux Commandes Perso (Externe)
# tablir 1 Liste de RGLES pour les autres Commandes (Interne)
# ex: commande = '...', descrA = "...", descrB = "...", conditions = {...}, actions = {...}
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# NOTE :
# ======
# LUA.SCD\LUA\UI\GAME\CHAT.LUA
# [48]local ChatOptions = Prefs.GetFromCurrentProfile("chatoptions") or defOptions
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# NOTE :
# ======
# AJOUTER INFO DBIT KBPS ENTRANT ET SORTANT DU JEU !!! :S
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
	

local Game = import('/lua/game.lua')
local MyModPath = Game.MyModPath


################################################################################
# IMPORTS

local Prefs = import('/lua/user/prefs.lua')
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local GameMain = import( MyModPath .. '/hook/lua/ui/game/gamemain.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local ConsoleCommands = import( MyModPath..'/hook/lua/ui/dialogs/ConsoleCommands.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local MyCameraShake = import( MyModPath .. '/hook/lua/ui/dialogs/MyCameraShake.lua' )
local MyGameSpeed = import( MyModPath .. '/hook/lua/ui/dialogs/MyGameSpeed.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


################################################################################
# VARIABLES


cmdLine     = { ligne = '', cmnde = '', param = 0 or false, muteCon = false, aide = '' , substLigne = '' }
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~




################################################################################
# FONCTIONS

--[[################################################################################
# Analyse et Interprete la Commande Courante Saisie  la CONSOLE.
# Filtre la Console pour permettre de CRER une NOUVELLE COMMANDE.
# Renvoie cmdLine pour traitement spcifique.
# exemple de saisie entre crochets : [cam_ShakeMult 25] (wow shaky ! :P)
# ==============================================================================
# CONVENTIONS :
# =====================
# # ligne = '' => Commande NON VALIDE => FILTRER, informer via AIDE.
# # ligne = 'abc' => Commande: VALIDE INTERNE, ou SI EXTERNE => RENVOYER INTACTE !
# # muteCon = false => NE PAS MODIFIER, 
# # substLigne = '' => AUCUNE Commande de SUBSITUTION, ne rien faire.
# # substLigne = 'abc' =>  Commande de SUBSITUTION, pour crer RACCOURCIS notamment.
# ==============================================================================
################################################################################]]--


function Interpreter( texte )
	cmdLine = { }       # RZ indispensable AVANT MJ !
	local ligne = ''
	local cmnde = ''
	local param = false
	local muteCon = false
	local aide = ''
	local substLigne = ''
	local txtMini = string.lower(texte)
	local cmdMini = ''
	
    if texte and string.len(texte) > 0 then # PAS DE TEST type = string, TEST string.len EST SUPERFLU ???
		
		# EXTERNE  la Console
		cmnde = 'Echo'
		cmdMini = string.lower( cmnde )..' ' # AVEC ESPACE pour permettre vrifier prsence Texte  afficher
		local cLong = string.len( cmdMini )
		if ( string.sub(txtMini, 1, cLong) == cmdMini ) and ( string.len( texte ) > cLong ) then
			param = string.sub( texte, (cLong+1), string.len(texte) )
			muteCon = true
			aide = param
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		elseif ( texte == cmnde ) or ( ( txtMini ..' ') == cmdMini ) then    # test AVEC ESPACE au cas o...
			return cmdLine    # NE RIEN FAIRE, DOIT RESTER <<SILENCIEUX>>
		end
		
		# EXTERNE  la Console
		cmnde = 'Info'
		cmdMini = string.lower( cmnde )..' ' # AVEC ESPACE pour permettre vrifier prsence Texte  afficher
		local cLong = string.len( cmdMini )
		if ( string.sub(txtMini, 1, cLong) == cmdMini ) and ( string.len( texte ) > cLong ) then
			param = string.sub( texte, (cLong+1), string.len(texte) )
			muteCon = true
			substLigne = string.format( 'con_echo %s', param )
			cmdLine = { ligne = cmnde, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		elseif ( texte == cmnde ) or ( ( txtMini ..' ') == cmdMini ) then    # test AVEC ESPACE au cas o...
			aide = LOC( '<LOC Info_mis_Txt>Text is missing ! example of use: Info Hello Halcyon!' )
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		end
		
		# INTERCEPTER "CON_ListCommands" ? DOIT SE COMPORTER COMME MA COMMANDE "Help" ???
		
		# EXTERNE  la Console
		#  faire: prvoir traitement pour commandes genre "Help AI", "Help CON"
		cmnde = 'Help'
		cmdMini = string.lower( cmnde )
		if ( txtMini == cmdMini ) then
			ConsoleCommands.ShowDetailedConsoleCommandsList()
			aide = LOC( '<LOC _done>done !' )
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		end
		
		# EXTERNE  la Console
		cmnde = 'CON_ClearDisplay'
		cmdMini = string.lower( cmnde )
		if ( txtMini == cmdMini ) then
			muteCon = true
			cmdLine = { ligne = cmnde, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		end
		
		# INTERNE  la Console
		cmnde = 'cam_ShakeMult'
		cmdMini = string.lower( cmnde )..' ' # AVEC ESPACE pour permettre vrifier Tentatives de Modif de cam_ShakeMult
		local cLong = string.len( cmdMini )
		if ( string.sub(txtMini, 1, cLong) == cmdMini ) then
			param = tonumber(  string.sub( texte, (cLong+1), string.len(texte) )  )
			if GameMain.NoCameraShake then
				aide = LOCF( '<LOC cmnde_aide_01>Command \"%s\" is Locked !  Enter \"NoShake\" if needed.', cmnde )
				cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
				return cmdLine
			else  # GRER LES CHANGEMENTS DE cam_ShakeMult !
				if (param == 0) then         # Retour en mode NoShake suite  commande 'cam_ShakeMult 0' !!!
					MyCameraShake.ToggleCameraShake()
				elseif (param > 0) then
					MyCameraShake.SetCameraShakeMultToCurProfile( param ) # MMORISER LES CHANGEMENTS DE cam_ShakeMult !
					MyCameraShake.SetCameraShakeMult( param, false )      # false pour mode non silencieux
				end
				aide = LOCF('<LOC cmnde_aide_02>New Value -> float cam_ShakeMult == %3.2f', param )
				cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
				return cmdLine
			end
		end
		
		# EXTERNE  la Console
		cmnde = 'NoShake'
		cmdMini = string.lower( cmnde )
		local cLong = string.len( cmnde )  # NoShake suivi d'autre chose est considr comme non valide
		if ( string.sub(txtMini, 1, cLong) == cmdMini ) and ( string.len( texte ) > cLong ) then
			param = string.sub( texte, (cLong+1), string.len(texte) )
			aide = LOCF('<LOC cmnde_aide_03>Unknown console command \"%s\"', texte)
			cmdLine = { ligne = ligne, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		elseif ( txtMini == cmdMini ) then
			MyCameraShake.ToggleCameraShake()
			if GameMain.NoCameraShake then
				param = 0
				aide = LOCF('<LOC cmnde_aide_04>%s is Enabled !', cmnde) .. LOC('<LOC mCC_toggle_info>Enter again this command to revert its effect.')
			else
				param = MyCameraShake.GetCameraShakeMult() or 1.0   # DEVRAIT TRE LA DERNIRE VALEUR SAISIE !
				aide = LOCF('<LOC cmnde_aide_05>%s is Disabled !', cmnde) .. LOC('<LOC mCC_toggle_info>Enter again this command to revert its effect.')
			end
			muteCon = true
			substLigne = string.format('cam_ShakeMult %3.2f', param )
			cmdLine = { ligne = cmnde, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
			return cmdLine
		end
		
	end
	
	# RENVOI de la COMMANDE ORIGINALE INTACTE
	local tDeb, tFin = string.find( texte, ' ' )
	if not (tDeb == nil) and not (tFin == nil) then
		cmnde = string.sub( texte, 1, (tDeb-1) )
		param = tonumber(  string.sub( texte, (tDeb+1), string.len(texte) )  )
	end
	cmdLine = { ligne = texte, cmnde = cmnde, param = param, muteCon = muteCon, aide = aide, substLigne = substLigne }
	return cmdLine
end


--[[################################################################################ ]]--


