--[[################################################################################
    # File      : /hook/lua/ui/dialogs/ConsolePlusHelp.lua                         #
    # Author    : Manimal                                                          #
    # Version   : 25 septembre 2008                                                #
    # Revision  : 16 mars 2009                                                     #
    #                                                                              #
    # Summary   : Help Window for Console Plus                                     #
    # Copyright : CopyLeft 2009 Manimal.                                           #
    ################################################################################]]--

local Game = import('/lua/game.lua')
local MyModPath = Game.MyModPath

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local Window = import('/lua/maui/window.lua').Window               # Console
local Group = import('/lua/maui/group.lua').Group                  # commune
local ItemList = import('/lua/maui/itemlist.lua').ItemList         # commune
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')        # commune
local UIUtil = import('/lua/ui/uiutil.lua')                        # commune
--local Text = import('/lua/maui/text.lua').Text                     # CreateUnit
local Tooltip = import('/lua/ui/game/tooltip.lua')
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


--[[################################################################################
# Affiche Fentre Aide Spcifique  Console Plus
################################################################################ ]]--
local fenAide = false

function DisplayConPlusHelpWindow()
    
	if fenAide then return end
	
	local texteAideCP = {
		"<LOC _texteAideCP_00>Console Plus uses the keyboard and mouse controls from the original console.",
		"",
		"<LOC _texteAideCP_01>How to get the complete Console commands list :",
		"",
		"<LOC _texteAideCP_02>- Click on the edit box on the bottom left part.",
		"<LOC _texteAideCP_03>- Enter \"Help\" that will display the complete Console commands list.",
		"",
		"",
		"<LOC _texteAideCB_01>How to Edit a command Batch:",
		"",
		"<LOC _texteAideCB_02>At the very first time you're using this console, the Batch should be empty.",
		"<LOC _texteAideCB_03>Left click on the Console's Edit field at the bottom left part of the Console.",
		"<LOC _texteAideCB_04>Type in the desired command that should pop up in a valid function names list.",
		"<LOC _texteAideCB_05>Then click on one of the 4 buttons below in order to :",
		"<LOC _texteAideCB_06>  [+] Copy + Paste a valid command to the Batch Editor's edit box.",
		"<LOC _texteAideCB_07>  [-] Delete a command from the Batch Editor's command list.",
		"<LOC _texteAideCB_08>  [x] Cancel a Copy + Paste operation that was performed through the [+] button.",
		"<LOC _texteAideCB_09>  [?] Show up the present Help window.",
		"",
		"<LOC _texteAideCB_09a>Alternatively, double-click with the right mouse button on a command that pops-up within",
		"<LOC _texteAideCB_09b>the regular commands list will perform the same like the [+] button.",
		"",
		"",
		"<LOC _texteAideCB_10>Possible Operations when the batch already contains some commands:",
		"",
		"<LOC _texteAideCB_11>  1- Press the Up and Down arrow key on the keybord in order to select any line from the Batch.",
		"<LOC _texteAideCB_12>     This line should show up in the edit box that's below the Batch.",
		"<LOC _texteAideCB_13>     Once you get the desired line, click on it in order to alter it.",
		"<LOC _texteAideCB_14>     Then press the Enter key in order to validate your changes.",
		"<LOC _texteAideCB_15>  2- Create a new commands Batch by clicking on the [New] button. (resets it totally)",
		"<LOC _texteAideCB_16>  3- In case of editing error, reload the commands Batch by clicking on the [Load] button.",
		"<LOC _texteAideCB_17>  4- Save the currently displayed commands batch by clicking on the [Save] button.",
		"<LOC _texteAideCB_18>  5- Run the current commands batch by clicking on the [Run] button.",
		"",
		"<LOC _texteAideCB_19>Last, 1 click on the \"box\" located above the Command Batch will open it.",
		"<LOC _texteAideCB_20>This will drop down the Commands List within which any line can be moved at will.",
		"<LOC _texteAideCB_21>through a drag\'n\'drop (left mouse bouton) after a command line is selected from the list.",
		"",
		"",
		"<LOC _texteAideMF_01>Manimal thanks you for having chosen his Mod Console Plus.",
	}
	
	
	# FENTRE d'AIDE
	local fenAideW = 600
	local fenAideH = 450
	--local fenAideT = ( 1024 - fenAideW ) / 2
	local fenAideT = 30
	local marge = 5
	local cphFontName = UIUtil.fixedFont
	local cphFontSize = 14
	
    local mainFrame = GetFrame(0)
	local nomFenAide = LOC('<LOC _ConPlusHelpWindow>Console Plus Help')
    local location = { Top = fenAideT, Left = fenAideT, Bottom = fenAideH + fenAideT, Right = fenAideW + fenAideT }
	
    # TAILLE FIXE -> #fenAide = Window( mainFrame, nomFenAide, nil, nil, false, true, false, 'ConsolePlus_help_window', location )
    fenAide = Window( mainFrame, nomFenAide, nil, nil, false, false, false, 'ConsolePlus_help_window', location )
    fenAide.Depth:Set( mainFrame:GetTopmostDepth() + 1 )
    fenAide:SetMinimumResize( fenAideW, fenAideH )
	
	Tooltip.AddButtonTooltip(fenAide._closeBtn, 'consplus_help_close')
	
    local clientAide = fenAide:GetClientGroup()
	
	# LISTE ITEMS contenant le texte d'aide
	tAideListe = ItemList( clientAide )
	LayoutHelpers.AtLeftTopIn( tAideListe, fenAide )
	tAideListe.Top:Set( function() return clientAide.Top() + 10 end )
	tAideListe.Right:Set( function() return clientAide.Right() - 40 end )
    tAideListe.Left:Set(function() return clientAide.Left() + 10 end)
    tAideListe.Bottom:Set(function() return clientAide.Bottom() - 10 end)
	tAideListe:SetColors(UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor(), UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor())
	tAideListe:SetFont( cphFontName, cphFontSize )

	for i, texteACP in texteAideCP do
		local tACP = LOC( texteACP )
		tAideListe:AddItem( tACP )
		if tAideListe:NeedsScrollBar() then
			UIUtil.CreateVertScrollbarFor( tAideListe )
		end
	end
    
	# FERMETURE FENTRE CONFIG
    fenAide.OnClose = function(self)
		self:Destroy()
		fenAide = false
	end
	
	return fenAide
end



