--[[################################################################################
    # File      : /hook/lua/ui/dialogs/MyCameraShake.lua                           #
    # Author    : GPG Devs / Manimal                                               #
    # Version   : 16 mars 2009                                                     #
    # Revision  : 18 mars 2009                                                     #
    #                                                                              #
    # Summary   : Fonctions Spcifiques au Rglage de Camera Shake                 #
    # Copyright : CopyLeft Manimal.                                                #
    ################################################################################]]--
	
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# NOTE :
# ======
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



local Game = import('/lua/game.lua')
local MyModPath = Game.MyModPath


################################################################################
# IMPORTS

local Prefs = import('/lua/user/prefs.lua')
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local GameMain = import( MyModPath .. '/hook/lua/ui/game/gamemain.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local console = import( MyModPath .. '/hook/lua/ui/dialogs/console.lua' )
local ConsolePlus = import( MyModPath .. '/hook/lua/ui/dialogs/ConsolePlus.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


################################################################################
# VARIABLES  ACCDER SITUES DANS Console.lua
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#ConsolePlus.cmdLine = { ligne = '', cmnde = '', param = 0 or false, muteCon = false, aide = '' , substLigne = '' }
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


################################################################################
# FONCTIONS SPCIFIQUES AU RGLAGE DE Camera Shake Mult


--[[################################################################################
# Fixer Valeur de cam_ShakeMult dans PROFILE
# Utilis par ToggleCameraShake()
################################################################################ ]]--

function SetCameraShakeMultToCurProfile( camShakeMult )
	if camShakeMult then
		if type(camShakeMult) == 'number' then
			Prefs.SetToCurrentProfile( 'ConsolePlus_cam_ShakeMult', camShakeMult )
		else
			WARN('### MANIMAL DEBUG:  MyCameraShake.lua -> Error in SetCameraShakeMultToCurProfile: Wrong TYPE -> '..type(camShakeMult)..' <-, a number was expected ! ###' )
		end
	end
end

--[[################################################################################
# Rcuperer Valeur de cam_ShakeMult du PROFILE -> Renvoie 1 NUMBER
# Utilis par ToggleCameraShake()
################################################################################ ]]--

function GetCameraShakeMultFromCurProfile()
	local camShakeMult = false    # Fixer sur FAUX pour gestion Erreur
	local prefCamShake = Prefs.GetFromCurrentProfile( 'ConsolePlus_cam_ShakeMult' ) or 1
	
	if prefCamShake and ( type(prefCamShake) == 'number' ) then
		camShakeMult = prefCamShake   #  CONCATENER AVEC tostring(camShakeMult) AVANT COMMANDE CONSOLE !!!
	else
		WARN('### MANIMAL DEBUG:  MyCameraShake.lua -> Error in GetCameraShakeMultFromCurProfile: Wrong TYPE -> '..type(prefCamShake)..' <-, a number was expected ! ###' )
	end
	
	return camShakeMult  # exemple de valeur 1.0000
end



--[[################################################################################
# Fixer Valeur de cam_ShakeMult de la CONSOLE -  0 = No Shake, n = valeur lue
# Utilis par ToggleCameraShake() - TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--

function SetCameraShakeMult( camShakeMult, muteCon )
	if camShakeMult then
		if ( type(camShakeMult) == 'number' ) then
			console.nouv_camShakeMult = camShakeMult    # Permet de se passer de la console pour lecture de camShakeMult dans les autres blocs de code
			local ligne = string.format( 'cam_ShakeMult %3.2f', camShakeMult )
			ConsolePlus.cmdLine= { ligne = ligne, cmnde = 'cam_ShakeMult', param = camShakeMult, muteCon = muteCon, aide = '', substLigne = '' }
			ConExecuteSave( ligne )
		else
			WARN('### MANIMAL DEBUG:  MyCameraShake.lua -> Error in SetCameraShakeMult: Wrong TYPE -> '..type(camShakeMult)..' <-, a number was expected  ! ###' )
		end
	end
end

--[[################################################################################
# Rcuprer DERNIER cam_ShakeMult PASS  la CONSOLE - Renvoie 1 NUMBER
# Utilis par ToggleCameraShake() - TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--

function GetCameraShakeMult()    # VERSION COURTE donnant tat des 2 variables utlises. 
	local camShakeMult = false
	if not( console.nouv_camShakeMult ) or (console.nouv_camShakeMult == nil)  or  (type(console.nouv_camShakeMult) ~= 'number') then
		WARN('### MANIMAL DEBUG:  MyCameraShake.lua -> Error in GetCameraShakeMult: Failed to get console.nouv_camShakeMult ! (type = '..type(console.nouv_camShakeMult)..', valeur = '..repr(console.nouv_camShakeMult)..')  ###')
	else
		camShakeMult = console.nouv_camShakeMult
	end
	if not( ConsolePlus.cmdLine.param ) or  (ConsolePlus.cmdLine.param == nil)  or  (type(ConsolePlus.cmdLine.param) ~= 'number')     then
		WARN('### MANIMAL DEBUG:  MyCameraShake.lua -> Error in GetCameraShakeMult: Failed to get ConsolePlus.cmdLine.param ! (type = '..type(ConsolePlus.cmdLine.param)..', valeur = '..repr(ConsolePlus.cmdLine.param)..')  ###')
	else
		camShakeMult = ConsolePlus.cmdLine.param
	end
	
	ConsolePlus.cmdLine = { ligne ='cam_ShakeMult', cmnde = 'cam_ShakeMult', param = camShakeMult, muteCon = true, aide = '', substLigne = '' }
	return camShakeMult      # exemple de valeur attendue 1.000
end



--[[################################################################################
# Fixer TAT de No_Shake dans PROFILE ( noShake = true ou false )
# Utilis par ToggleCameraShake()
################################################################################ ]]--

function SetNoShakeToCurProfile( noShake )
	if ( noShake ~= nil ) then
		if ( type( noShake ) == 'boolean' ) then
			Prefs.SetToCurrentProfile( 'ConsolePlus_No_Shake', noShake )
		else
			WARN('### MANIMAL DEBUG:  MyCameraShake.lua -> Error in SetNoShakeToCurProfile: Wrong TYPE -> '..type(noShake)..' <-, a boolean was expected ! ###' )
		end
	end
end

--[[################################################################################
# Rcuperer TAT de No_Shake dans PROFILE -> Renvoie 1 BOOLEAN
# Utilis par ToggleCameraShake()
################################################################################ ]]--

function GetNoShakeFromCurProfile()
	local noShake = false    # Fixer sur FAUX pour gestion Erreur
	local prefNoShake = Prefs.GetFromCurrentProfile('ConsolePlus_No_Shake') or false
	
	if ( prefNoShake ~= nil ) then
		if ( type( prefNoShake ) == 'boolean' ) then
			noShake = prefNoShake
		else
			WARN('### MANIMAL DEBUG:  MyCameraShake.lua -> Error in GetNoShakeFromCurProfile: a boolean was expected ! ###' )
		end
	end
	
	return noShake  # exemple de valeur true
end



--[[################################################################################
# INITIALISATION cam_ShakeMult et NoShake avec MISE  JOUR du PROFILE
# TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--

function InitCameraShake()
	local prof_camShakeMult = GetCameraShakeMultFromCurProfile() or 1  # cam_ShakeMult PRCDENT STOCK DANS PROFIL
	SetCameraShakeMult( prof_camShakeMult, true )                      # RESTAURER VALEUR de cam_ShakeMult
end



--[[################################################################################
# BASCULER cam_ShakeMult et NoShake avec MISE  JOUR du PROFILE
# TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--

function ToggleCameraShake()
	local actu_camShakeMult = GetCameraShakeMultFromCurProfile()  or 1  # cam_ShakeMult Courant
	local noCameraShake = GetNoShakeFromCurProfile()
	# FOR SOME REASON IT WONT GET CORRECT VALUE OF noCameraShake AT THIS STEP
	if noCameraShake then
		console.nouv_camShakeMult = console.prec_camShakeMult    # Rcuprer cam_ShakeMult PRCDENT (ractiver)
	else
		console.nouv_camShakeMult = 0                            # AUTORISER CAMERA SHAKE
	end
	noCameraShake = not( noCameraShake )                         # BASCULER TAT noCameraShake ( true pour NoShake )
	GameMain.NoCameraShake = noCameraShake                       # M  J TAT GameMain.NoCameraShake
	console.prec_camShakeMult = actu_camShakeMult                # Courant deviendra Prcdent
	SetCameraShakeMultToCurProfile( console.nouv_camShakeMult )  # Nouveau cam_ShakeMult dans Profil Courant
	SetCameraShakeMult( console.nouv_camShakeMult, true )        # Appliquer Nouveau cam_ShakeMult
	SetNoShakeToCurProfile( noCameraShake )                      # Enregistrer TAT de NoShake dans Profil Courant
end


--[[################################################################################ ]]--
