--[[################################################################################
    # File      : /hook/lua/ui/dialogs/MyGameSpeed.lua                             #
    # Author    : Manimal                                                          #
    # Version   : 16 mars 2009                                                     #
    # Revision  : 18 mars 2009                                                     #
    #                                                                              #
    # Summary   : Fonctions Spcifiques au Rglage de Game Speed                   #
    # Copyright : CoplyLeft 2009 Manimal.                                          #
    ################################################################################]]--

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# NOTE :
# ======
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
 
	

local Game = import('/lua/game.lua')
local MyModPath = Game.MyModPath


################################################################################
# IMPORTS

local Prefs = import('/lua/user/prefs.lua')
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local GameMain = import( MyModPath .. '/hook/lua/ui/game/gamemain.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local console = import( MyModPath .. '/hook/lua/ui/dialogs/console.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



################################################################################
# FONCTIONS SPCIFIQUES AU RGLAGE DE Game Speed


--[[################################################################################
# Fixer Valeur de GameSpeed dans PROFILE
################################################################################ ]]--

function SetMyGameSpeedToCurProfile( gameSpeed )
	if gameSpeed then
		if type( gameSpeed ) == 'number' then
			Prefs.SetToCurrentProfile( 'ConsolePlus_MyGameSpeed', gameSpeed )
		else
			WARN('### MANIMAL DEBUG:  MyGameSpeed.lua -> Error in SetMyGameSpeedToCurProfile: Wrong TYPE -> '..type(gameSpeed)..' <-, a number was expected ! ###' )
		end
	end
end

--[[################################################################################
# Rcuperer Valeur de GameSpeed du PROFILE -> Renvoie 1 NUMBER
# Utilis par ToggleCameraShake()
################################################################################ ]]--

function GetMyGameSpeedFromCurProfile()
	local gameSpeed = false    # Fixer sur FAUX pour gestion Erreur
	local prefGameSpeed = Prefs.GetFromCurrentProfile( 'ConsolePlus_MyGameSpeed' ) or 0
	
	if prefGameSpeed and ( type(prefGameSpeed) == 'number' ) then
		gameSpeed = prefGameSpeed   #  CONCATENER AVEC tostring(gameSpeed) AVANT COMMANDE CONSOLE !!!
	else
		WARN('### MANIMAL DEBUG:  MyGameSpeed.lua -> Error in GetMyGameSpeedFromCurProfile: Wrong TYPE -> '..type(prefGameSpeed)..' <-, a number was expected ! ###' )
	end
	
	return gameSpeed  # exemple de valeur : 1
end



--[[################################################################################
# Fixer Valeur de Game Speed sur  ZERO = Defaut
# - TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--

--function ResetMyGameSpeed( muteCon )
function ResetMyGameSpeed()
	console.nouv_gameSpeed = 0    # Permet de se passer de la console pour lecture de camShakeMult dans les autres blocs de code
	SetGameSpeed( 0 )
	SetMyGameSpeedToCurProfile( gameSpeed )
end


--[[################################################################################
# Fixer Valeur de Game Speed -  0 = Defaut, n = valeur lue
# WLD_GameSpeed : Set a new game speed  - TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--

function SetMyGameSpeed( gameSpeed )  --function SetMyGameSpeed( gameSpeed, muteCon )
	if  gameSpeed  then
		if ( type( gameSpeed ) == 'number' ) then
			if ( gameSpeed >= -10 ) and  ( gameSpeed <= 10 ) then
				console.nouv_gameSpeed = gameSpeed    # Permet de se passer de la console pour lecture de camShakeMult dans les autres blocs de code
				--SetGameSpeed( gameSpeed )  -- ConExecute( "WLD_GameSpeed " .. gameSpeed )
			else
				WARN('### MANIMAL DEBUG:  MyGameSpeed.lua -> Error in SetMyGameSpeed: Out of Range Value -> '..tostring(gameSpeed)..' <-, must be within -10 and 10  ! ###' )
			end
		else
			WARN('### MANIMAL DEBUG:  MyGameSpeed.lua -> Error in SetMyGameSpeed: Wrong TYPE -> '..type(gameSpeed)..' <-, a number was expected  ! ###' )
		end
	end
end

--[[################################################################################
# Rcuprer DERNIERE valeur de Game Speed  - Renvoie 1 NUMBER
# - TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--

function GetMyGameSpeed()    # VERSION COURTE donnant tat de la variable utlise. 
	local gameSpeed = false
	if not( console.nouv_gameSpeed ) or (console.nouv_gameSpeed == nil) or ( type(console.nouv_gameSpeed) ~= 'number' ) then
		WARN('### MANIMAL DEBUG:  MyGameSpeed.lua -> Error in GetMyGameSpeed: Failed to get nouv_gameSpeed ! (type = '..type(console.nouv_gameSpeed)..', valeur = '..repr(console.nouv_gameSpeed)..')  ###')
	else
		gameSpeed = console.nouv_gameSpeed  -- GetGameSpeed()
	end
	
	return gameSpeed      # exemple de valeur attendue : 1
end



--[[################################################################################
# Fixer TAT de RunAtMyGameSpeed dans PROFILE ( runAtMyGameSpeed = true ou false )
# Utilis par ToggleMyGameSpeed()
################################################################################ ]]--

function SetRunAtMyGameSpeedToCurProfile( runAtMyGameSpeed )
	if ( runAtMyGameSpeed ~= nil ) then
		if ( type( runAtMyGameSpeed ) == 'boolean' ) then
			Prefs.SetToCurrentProfile( 'ConsolePlus_RunAtMyGameSpeed', runAtMyGameSpeed )
		else
			WARN('### MANIMAL DEBUG:  MyGameSpeed.lua -> Error in SetRunAtMyGameSpeedToCurProfile: Wrong TYPE -> '..type(runAtMyGameSpeed)..' <-, a boolean was expected ! ###' )
		end
	end
end

--[[################################################################################
# Rcuperer TAT de RunAtMyGameSpeed dans PROFILE -> Renvoie 1 BOOLEAN
# Utilis par ToggleMyGameSpeed()
################################################################################ ]]--

function GetRunAtMyGameSpeedFromCurProfile()
	local runAtMyGameSpeed = false    # Fixer sur FAUX pour gestion Erreur
	local prefRunAtMyGameSpeed = Prefs.GetFromCurrentProfile( 'ConsolePlus_RunAtMyGameSpeed' ) or false
	
	if ( prefRunAtMyGameSpeed ~= nil ) then
		if ( type( prefRunAtMyGameSpeed ) == 'boolean' ) then
			runAtMyGameSpeed = prefRunAtMyGameSpeed
		else
			WARN('### MANIMAL DEBUG:  MyGameSpeed.lua -> Error in GetRunAtMyGameSpeedFromCurProfile: a boolean was expected ! ###' )
		end
	end
	
	return runAtMyGameSpeed  # exemple de valeur true
end



--[[################################################################################
# INITIALISATION Valeur de Game Speed et tat de RunAtMyGameSpeed avec MISE  JOUR du PROFILE
# TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--

function InitMyGameSpeed()
	local prof_gameSpeed = GetMyGameSpeedFromCurProfile() or 0   # Game Speed PRCDENT LU DANS PROFIL
	SetMyGameSpeed( prof_gameSpeed )                             # RESTAURER Game Speed SELON PREFS
	SetGameSpeed( prof_gameSpeed )                               # AJUSTER VITESSE DU JEU SELON PREFS
end



--[[################################################################################
# BASCULER Valeur de Game Speed et tat de RunAtMyGameSpeed avec MISE  JOUR du PROFILE
# TRAITEMENT <<SILENCIEUX>> !!!
################################################################################ ]]--
# console.prec_gameSpeed PERMET DE RESTAURER LA VALEUR << PRCDENTE >>  DE GameSpeed
# ACTUELLEMENT console.prec_gameSpeed CONTIENT LA VALEUR PAR DFAUT
# IL FAUDRA MODIFIER LA VALEUR DE console.prec_gameSpeed EN FONCTION DES COMMANDES CLAVIER (+ et -)

function ToggleMyGameSpeed()
	local newGameSpeed = 0
	local runAtMyGameSpeed = GetRunAtMyGameSpeedFromCurProfile()
	# FOR SOME REASON IT WONT GET CORRECT VALUE OF GameMain.RunAtMyGameSpeed AT THIS STEP
	if  runAtMyGameSpeed  then                           # ACTIVER VITESSE PRCDENTE (regular setting)
		newGameSpeed = console.prec_gameSpeed
	else                                                 # ACTIVER VITESSE PRFRE (console config setting)
		newGameSpeed = console.nouv_gameSpeed
	end
	SetGameSpeed( newGameSpeed )                         # APPLIQUER NOUVEAU Game Speed (FAVORI)
	runAtMyGameSpeed = not( runAtMyGameSpeed )           # BASCULER TAT RunAtMyGameSpeed ( true pour VITESSE du JEU PERSO )
	GameMain.RunAtMyGameSpeed = runAtMyGameSpeed         # M  J TAT GameMain.RunAtMyGameSpeed 
	SetRunAtMyGameSpeedToCurProfile( runAtMyGameSpeed )  # ENREGISTRER TAT de RunAtMyGameSpeed dans Profil Courant
end


--[[################################################################################ ]]--
