--[[################################################################################
    # File      : /hook/lua/ui/dialogs/console.lua                                 #
    # Author    : GPG Devs / Manimal                                               #
    # Version   : 25 septembre 2008                                                #
    # Revision  : 04 avril 2009                                                    #
    #                                                                              #
    # Summary   : Console that brings some new features                            #
    # Copyright :  2005 Gas Powered Games, Inc. All rights reserved.              #
    ################################################################################]]--
	
## NBR LIGNES ORIGINAL = 236

# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# MODIFS  FAIRE :
# ================
# IMPRATIVEMENT AJOUTER 1 BOUTON [RUN BATCH AT START] DANS PANNEAU DE CONFIG
# IMPRATIVEMENT AJOUTER 1 BOUTON [UNDO] DANS PANNEAU DE BATCH EDITOR
# AJOUTER 1 BOUTON [Clear Screen] trs pratique !!!!
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# NOTE :
# ======
# BEL EXEMPLE DE RCUP DE LIGNE DE COMMANDES =
# lua.scd\lua\SinglePlayerLaunch.lua ligne 137 -> GetCommandLineOptions(isPerfTest)
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
# NOTE :
# ======
# AJOUTER 1 BOUTON [List Commands] trs pratique !!!!
# AJOUTER INFO DBIT KBPS ENTRANT ET SORTANT DU JEU !!! :S
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


local Game = import('/lua/game.lua')
local MonMod = Game.MonMod
local MyModPath = Game.MyModPath


################################################################################
# IMPORTS Console

local Bitmap = import('/lua/maui/bitmap.lua').Bitmap               # commune
local Border = import('/lua/maui/border.lua').Border               # commune
local Edit = import('/lua/maui/edit.lua').Edit                     # commune
local Group = import('/lua/maui/group.lua').Group                  # commune
local ItemList = import('/lua/maui/itemlist.lua').ItemList         # commune
local LayoutHelpers = import('/lua/maui/layouthelpers.lua')        # commune
local UIUtil = import('/lua/ui/uiutil.lua')                        # commune
local Control = import('/lua/maui/control.lua').Control            # Console
local IntegerSlider = import('/lua/maui/slider.lua').IntegerSlider # Console
local Prefs = import('/lua/user/prefs.lua')                        # Console
local Scrollbar = import('/lua/maui/scrollbar.lua').Scrollbar      # Console
local Window = import('/lua/maui/window.lua').Window               # Console
local Checkbox = import('/lua/maui/checkbox.lua').Checkbox         # CreateUnit
local Combo = import('/lua/ui/controls/combo.lua').Combo           # CreateUnit
local RadioGroup = import('/lua/maui/mauiutil.lua').RadioGroup     # CreateUnit
local Text = import('/lua/maui/text.lua').Text                     # CreateUnit
local Tooltip = import('/lua/ui/game/tooltip.lua')


################################################################################
# VARIABLES Console

local commandDeque = {}
local maxCommandDequeSize = 10
local currentCommandDequeIndex = 0
local currentText = ""
local consoleFontName = UIUtil.fixedFont
local consoleFontSize = 12
COfontWidth = 8      # Measured from screenshots
COfontHeight = 12    # Measured from screenshots
local window = false


################################################################################
# IMPORTS Perso

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local Utiles = import( MyModPath .. '/schook/lua/system/mesUtiles.lua' )  # Mes Utiles
local GameMain = import( MyModPath .. '/hook/lua/ui/game/gamemain.lua' )  # WILL TOGGLE NoCameraShake STATE AT GAME START.
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local ConsolePlus = import( MyModPath .. '/hook/lua/ui/dialogs/ConsolePlus.lua' )
local ConsolePlusHelp = import( MyModPath .. '/hook/lua/ui/dialogs/ConsolePlusHelp.lua' )
local ConsolePlusUtils = import( MyModPath .. '/hook/lua/ui/dialogs/ConsolePlusUtils.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local MyCameraShake = import( MyModPath .. '/hook/lua/ui/dialogs/MyCameraShake.lua' )
local MyGameSpeed = import( MyModPath .. '/hook/lua/ui/dialogs/MyGameSpeed.lua' )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local ConsoleCommands = import( MyModPath .. '/hook/lua/ui/dialogs/ConsoleCommands.lua' )
local mesCommandesConsole = ConsoleCommands.mesCommandesConsole
local myConTextMatches = ConsoleCommands.myConTextMatches
--local GetCommandsListFromConsole = ConsoleCommands.GetCommandsListFromConsole
--local CreateDetailedConsoleCommandsList = ConsoleCommands.CreateDetailedConsoleCommandsList
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local TooltipPlus = import( MyModPath .. '/hook/lua/ui/game/TooltipPlus.lua' )
local CreateCommandTooltipsFromCommandsList = TooltipPlus.CreateCommandTooltipsFromCommandsList  -- requires the list made by CreateDetailedConsoleCommandsList()
--local GetCommandTooltipFromCommandLine = TooltipPlus.GetCommandTooltipFromCommandLine
local GetCommandTooltipListFromBatch = TooltipPlus.GetCommandTooltipListFromBatch
--local GetCommandTooltipListFromFuncsList = TooltipPlus.GetCommandTooltipListFromFuncsList
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~


################################################################################
# VARIABLES Perso

#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local dialog = false
itemBufferSize = 1000    # CHANG Buffer 300 -> 1000 # NBR REL = 434 commandes (FA v.1.5.3599) + mes commandes + autant de descriptions avec Help
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
myConSplash = LOCF('<LOC _myConSplash>\"%s v.%d by %s\"', MonMod.name, MonMod.version, MonMod.author)
hideMyConSplash = false
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
recupText = { }  # DUMP TEMP Console
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local AlphaConSliderLocked = Prefs.GetFromCurrentProfile('ConsolePlus_alpha_locked') or false
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local batchIsLoaded = false
local monBatch = {}
local derniereEntree = ""
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
consW = 400           # scrollbar width = 38 is included in this width
consH = 300
batchW = 300
btnW = 64             # Measures obtained from my own textures
toolPW = btnW + 6
menuPW = btnW + 6
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
prec_camShakeMult = 1  # INIT = cam_ShakeMult AVEC Secousses Camera 
nouv_camShakeMult = 1  # INIT = cam_ShakeMult AVEC Secousses Camera
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
prec_gameSpeed = 0  # INIT = Game Speed PAR DFAUT
nouv_gameSpeed = 0  # INIT = Game Speed PAR DFAUT
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
local batch = {} # Regroupera Toutes les Fonctions du Batch ( OnAdd, OnDel, OnLoad, etc )
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~



--[[################################################################################
# FONCTIONS
################################################################################]]--



function InsertConCommandInQueue(text)
    table.insert(commandDeque, text)
    if table.getn(commandDeque) > maxCommandDequeSize then
        table.remove(commandDeque, 1)
    end
    currentCommandDequeIndex = table.getn(commandDeque)
end



--[[################################################################################
# MANIMAL's CONSOLE PLUS CONFIGURATION WINDOW - FEATURES SOME MORE SETTINGS ! BD
################################################################################]]--


function ConfigWindow( parent )
	#  VOIR pour TABS : lua.scd/lua/ui/dialogs/score.lua LIGNE 511
    # SetNewPage(tabControl)    #-- when a new page is selected, create the page and deal with the tab correctly
	
	if window then return end
	
	local CONSOLE_LINES = Prefs.GetFromCurrentProfile("console_size") or 5
	local CONSOLE_FADE_DELAY = Prefs.GetFromCurrentProfile("console_fade_delay") or 3
	local CONSOLE_FONT_SIZE = Prefs.GetFromCurrentProfile("console_font_size") or 12
	local CONSOLE_FONT_COLOR = Prefs.GetFromCurrentProfile("console_font_color") or "FFbadbdb"
	local CONSOLE_FONT = Prefs.GetFromCurrentProfile("console_font") or "Zeroes Three"
	
	# ==========================================================================
	# FENTRE de CONFIG
	
	local windowT = 30
	local sliderPanelH = 60
	local ncsPanelH = 40
	local echPanelH = 60 + 40 + 40 # 1 SLIDER pour Alpha Echo + 2 BOUTONS VOIR PLUS ! (5 rglages)
	local clientInHeight = sliderPanelH + ncsPanelH + echPanelH
	local clientInWidth = 160
	local margin = 5
	local fontSize = 14
	
	local windowName = ConsolePlusUtils.FilteredLOC('<LOC console_0000>Console Config')
    window = Window(GetFrame(0), windowName, nil, nil, nil, true)
    window.Left:Set(function() return parent.Left() + 10 end)
    window.Top:Set(function() return parent.Top() + windowT end)
    window.Right:Set(function() return parent.Left() + 280 end) # SEMBLE CORRECT
    window.Bottom:Set(function() return parent.Top() + windowT + clientInHeight end)
    window.Depth:Set(GetFrame(0):GetTopmostDepth() + 1)
    
	Tooltip.AddButtonTooltip(window._closeBtn, 'consplus_config_close')
	
    local client = window:GetClientGroup()
	
    # New items will be part of Groups below 
	client.sliPanel = Group( client, "sliPanel" )
	sliPan = client.sliPanel
    LayoutHelpers.AtLeftTopIn( sliPan, client, margin, margin )
    sliPan.Width:Set( clientInWidth )
    sliPan.Height:Set( sliderPanelH )
	
    client.echPanel = Group( client, "echPanel" ) # servira pour rglages echo (echPanel)
	echPan = client.echPanel
    LayoutHelpers.Below( echPan, sliPan )
    echPan.Width:Set( clientInWidth )
    #echPan.Height:Set( echPanelH )
    echPan.Height:Set( 2 ) # temporaire pour mise au point ncsPanel
	
    client.ncsPanel = Group( client, "ncsPanel" )  -- New Console Special Features related
    ncsPan = client.ncsPanel
    LayoutHelpers.Below( ncsPan, echPan )
    ncsPan.Width:Set( clientInWidth )
    ncsPan.Height:Set( ncsPanelH )
	
	# ==========================================================================
	# RGLAGE ALPHA de la CONSOLE : label + valeur courante + glissire
	
	local defAlphaValue = Prefs.GetFromCurrentProfile('console_alpha') or 1
    defAlphaValue = defAlphaValue * 100

	# LABEL
	local alphaLabelName = ConsolePlusUtils.FilteredLOCF("<LOC console_alpha>Alpha: %d%%" , defAlphaValue)
	sliPan.AlphaConSliderLabel = UIUtil.CreateText( sliPan, alphaLabelName, fontSize )
    LayoutHelpers.AtLeftTopIn( sliPan.AlphaConSliderLabel, sliPan, margin, margin )
	
	# GLISSIRE 
    sliPan.AlphaConSlider = IntegerSlider( sliPan, false, 20, 100, 1,     # NE PAS DEPASSER 100 SINON VALEURS > 100 % !!!
			UIUtil.SkinnableFile('/slider02/slider_btn_up.dds'),
			UIUtil.SkinnableFile('/slider02/slider_btn_over.dds'),
			UIUtil.SkinnableFile('/slider02/slider_btn_down.dds'), 
            UIUtil.SkinnableFile('/dialogs/options-02/slider-back_bmp.dds') )
    LayoutHelpers.Below( sliPan.AlphaConSlider, sliPan.AlphaConSliderLabel )
	
	Tooltip.AddControlTooltip(sliPan.AlphaConSlider._background, 'consplus_config_alphaSlider')
	
	local oldAlphaConSliderThumbHandleEvent = sliPan.AlphaConSlider._thumb.HandleEvent
	sliPan.AlphaConSlider._thumb.HandleEvent = function( control, event )
		eventHandled = false 
		if AlphaConSliderLocked then
			eventHandled = true
		else
			eventHandled = oldAlphaConSliderThumbHandleEvent( control, event )
		end
		return eventHandled
    end
	
	local oldAlphaConSliderBkgndHandleEvent = sliPan.AlphaConSlider._background.HandleEvent
	sliPan.AlphaConSlider._background.HandleEvent = function( control, event )
		eventHandled = false 
		if AlphaConSliderLocked then
			eventHandled = true
		else
			eventHandled = oldAlphaConSliderBkgndHandleEvent( control, event )
		end
		return eventHandled
    end
	
	sliPan.AlphaConSlider.OnValueSet = function(self, newValue)   end
	
    sliPan.AlphaConSlider.OnValueChanged = function(self, newValue)
		newValue = MATH_IRound( newValue )      # POUR CONTROLE VALEUR => ARRONDI: keep INTEGRAL part ONLY
		parent:SetAlpha( newValue / 100, true ) # MODIFIER TRANSPARENCE DE LA FENETRE CONFIG !
		sliPan.AlphaConSliderLabel:SetText( ConsolePlusUtils.FilteredLOCF("<LOC console_alpha>Alpha: %d%%", newValue) )
    end
	
    sliPan.AlphaConSlider:SetValue(defAlphaValue)
    
	# ==========================================================================
	# VERROU RGLAGE ALPHA de la CONSOLE [LOCK] :  case  cocher + label  
	
	# CASE  COCHER
    sliPan.AlphaConSliderLockBtn = UIUtil.CreateCheckboxStd( sliPan, '/dialogs/check-box_btn/radio' )
    LayoutHelpers.RightOf( sliPan.AlphaConSliderLockBtn, sliPan.AlphaConSlider, margin )
	LayoutHelpers.AtVerticalCenterIn( sliPan.AlphaConSliderLockBtn, sliPan )
    sliPan.AlphaConSliderLockBtn.key = 'consolealpha'
    
	Tooltip.AddCheckboxTooltip(sliPan.AlphaConSliderLockBtn, 'consplus_config_alphaSliderLock')
	
	# LABEL
	local alsLabel = "<LOC lock_asl>Lock"
    sliPan.AlphaConSliderLockBtnLabel = UIUtil.CreateText( sliPan, alsLabel, fontSize, UIUtil.bodyFont )
    LayoutHelpers.Above( sliPan.AlphaConSliderLockBtnLabel, sliPan.AlphaConSliderLockBtn )
	
    sliPan.AlphaConSliderLockBtn.OnCheck = function( self, checked )
		if self:IsChecked() then                                         # DSACTIVER GLISSIRE TRANSPARENCE
			sliPan.AlphaConSlider:SetAlpha( 0.5, true )                  # VISIBILIT GLISSIRE = RDUITE
			AlphaConSliderLocked = true                                
		else                                                             # ACTIVER GLISSIRE TRANSPARENCE
			sliPan.AlphaConSlider:SetAlpha( 1, true )                    # VISIBILIT GLISSIRE = NORMALE
			AlphaConSliderLocked = false                               
		end
		Prefs.SetToCurrentProfile( 'ConsolePlus_alpha_locked', AlphaConSliderLocked )
    end
	if AlphaConSliderLocked then
		sliPan.AlphaConSliderLockBtn:SetCheck(true)
	else
		sliPan.AlphaConSliderLockBtn:SetCheck(false)
	end
	
	# ==========================================================================
	# BOUTON [NO CAM SHAKE] : case  cocher + label

	local ncsNoCamShakeLabel = "<LOC lock_ncs>No Camera Shake"
	local defNoCamShakeState = Prefs.GetFromCurrentProfile( 'ConsolePlus_No_Shake' ) or false  # INIT = No_Shake PRCDENT STOCK DANS PROFIL ou bien VALEUR PAR DFAUT
    
	# CASE  COCHER
    ncsPan.noCamShakeBtn = UIUtil.CreateCheckboxStd( ncsPan, '/dialogs/check-box_btn/radio' )
    LayoutHelpers.AtLeftTopIn( ncsPan.noCamShakeBtn, ncsPan, margin, margin )
    ncsPan.noCamShakeBtn.key = 'camshakeconf'
	
	Tooltip.AddCheckboxTooltip(ncsPan.noCamShakeBtn, 'consplus_config_noCamShake')
	
	ncsPan.noCamShakeBtn:SetCheck( defNoCamShakeState )  # FOR SOME REASON IT WONT GET CORRECT VALUE OF GameMain.NoCameraShake
    
	# LABEL
    ncsPan.noCamShakeBtnLabel = UIUtil.CreateText( ncsPan, ncsNoCamShakeLabel, fontSize, UIUtil.bodyFont )
    LayoutHelpers.RightOf( ncsPan.noCamShakeBtnLabel, ncsPan.noCamShakeBtn )
    LayoutHelpers.AtVerticalCenterIn( ncsPan.noCamShakeBtnLabel, ncsPan.noCamShakeBtn )
    
	local oldNoCamShakeBtnOnClick = ncsPan.noCamShakeBtn.OnClick
    ncsPan.noCamShakeBtn.OnClick = function( self, modifiers )
		oldNoCamShakeBtnOnClick( self, modifiers )       # pour appel de ToggleCheck()
		MyCameraShake.ToggleCameraShake()                # , TOGGLE NE MODIFIE QUE ETAT BOOLEEN ?
    end
		
	
	# ==========================================================================
	# RGLAGE GAME SPEED via la CONSOLE : label + valeur courante + glissire
	
	local defGameSpeedValue = Prefs.GetFromCurrentProfile( 'ConsolePlus_MyGameSpeed' ) or 0  # INIT = Game Speed PRCDENT STOCK DANS PROFIL ou bien VALEUR PAR DFAUT
	
	# LABEL
	local gameSpeedLabelName = ConsolePlusUtils.FilteredLOCF("<LOC consplus_GameSpeed>Game Speed: %+d" , defGameSpeedValue)
	ncsPan.GameSpeedSliderLabel = UIUtil.CreateText( ncsPan, gameSpeedLabelName, fontSize )
    LayoutHelpers.Below( ncsPan.GameSpeedSliderLabel, ncsPan.noCamShakeBtn, margin )
	
	# GLISSIRE 
    ncsPan.GameSpeedSlider = IntegerSlider( ncsPan, false, -10, 10, 1,     # PLAGE de VALEURS: -10 .. 0 .. +10
			UIUtil.SkinnableFile('/slider02/slider_btn_up.dds'),
			UIUtil.SkinnableFile('/slider02/slider_btn_over.dds'),
			UIUtil.SkinnableFile('/slider02/slider_btn_down.dds'), 
            UIUtil.SkinnableFile('/dialogs/options-02/slider-back_bmp.dds') )
    LayoutHelpers.Below( ncsPan.GameSpeedSlider, ncsPan.GameSpeedSliderLabel )
	
	Tooltip.AddControlTooltip( ncsPan.GameSpeedSlider._background, 'consplus_config_gamespeedslider' )
	
	ncsPan.GameSpeedSlider.OnValueSet = function( self, newValue )   end
	
    ncsPan.GameSpeedSlider.OnValueChanged = function( self, newValue )
		newValue = MATH_IRound( newValue )   # POUR CONTROLE VALEUR => ARRONDI: keep INTEGRAL part ONLY
		MyGameSpeed.SetMyGameSpeed( newValue )             # MODIFIER LA VITESSE PRFRE DU JEU ! (NON ACTIVE)
		MyGameSpeed.SetMyGameSpeedToCurProfile( newValue ) # SAUVEGARDER LA VITESSE PRFRE DU JEU ! (NON ACTIVE)
		ncsPan.GameSpeedSliderLabel:SetText( ConsolePlusUtils.FilteredLOCF("<LOC consplus_GameSpeed>Game Speed: %+d", newValue) )
    end
	
    ncsPan.GameSpeedSlider:SetValue( defGameSpeedValue )
    
	# ==========================================================================
	# BOUTON [RUN AT MY GAME SPEED] : case  cocher + label
	
	local ncsMyGameSpeedLabel = "<LOC lock_ramgs>Use my Prefered Game Speed"
	local defMyGameSpeedState = Prefs.GetFromCurrentProfile( 'ConsolePlus_RunAtMyGameSpeed' ) or false  # INIT = RunAtMyGameSpeed PRCDENT STOCK DANS PROFIL ou bien VALEUR PAR DFAUT
    
	# CASE  COCHER
    ncsPan.MyGameSpeedBtn = UIUtil.CreateCheckboxStd( ncsPan, '/dialogs/check-box_btn/radio' )
    LayoutHelpers.Below( ncsPan.MyGameSpeedBtn, ncsPan.GameSpeedSlider, margin )
    ncsPan.MyGameSpeedBtn.key = 'gamespeedconf'
	
	Tooltip.AddCheckboxTooltip( ncsPan.MyGameSpeedBtn, 'consplus_config_mygamespeed' )
	
	ncsPan.MyGameSpeedBtn:SetCheck( defMyGameSpeedState )  # FOR SOME REASON IT WONT GET CORRECT VALUE OF GameMain.RunAtMyGameSpeed
    
	# LABEL
    ncsPan.MyGameSpeedBtnLabel = UIUtil.CreateText( ncsPan, ncsMyGameSpeedLabel, fontSize, UIUtil.bodyFont )
    LayoutHelpers.RightOf( ncsPan.MyGameSpeedBtnLabel, ncsPan.MyGameSpeedBtn )
    LayoutHelpers.AtVerticalCenterIn( ncsPan.MyGameSpeedBtnLabel, ncsPan.MyGameSpeedBtn )
    
	local oldMyGameSpeedBtnOnClick = ncsPan.MyGameSpeedBtn.OnClick
    ncsPan.MyGameSpeedBtn.OnClick = function( self, modifiers )  # THIS CAN GET CORRECT VALUE OF GameMain.RunAtMyGameSpeed
		oldMyGameSpeedBtnOnClick( self, modifiers )       # pour appel de ToggleCheck()
		MyGameSpeed.ToggleMyGameSpeed()                   # ACTIVER OU NON LA VITESSE PRFRE, TOGGLE NE MODIFIE QUE ETAT BOOLEEN
    end
	
	# ==========================================================================
	# FERMETURE FENTRE CONFIG
	# ========================
    window.OnClose = function(self)
        Prefs.SetToCurrentProfile('console_alpha', sliPan.AlphaConSlider:GetValue()/100)
        window:Destroy()
        window = false
    end
end




# ==========================================================================
# MUTE CONSOLE FOR EXECUTING COMMANDS WITHOUT CONSOLE ECHO
# ==========================================================================
function AddMuteOutputHandler()
	return AddConsoleOutputReciever( function(text)	-- set up output control to recieve console spew
		table.insert( recupText, text )    # BIEN GRER LE TAMPON recupText SINON GARE AU DEBORDEMENT ! :[
	end)
end
	
function RemoveMuteOutputHandler()
	if muteOutputHandler then
		RemoveConsoleOutputReciever( muteOutputHandler )
	end
end
# ==========================================================================



--[[################################################################################
#    C O N S O L E   P L U S    b y    M A N I M A L
################################################################################]]--
function CreateDialog()
	
    local mainFrame = GetFrame(0)

	# ==========================================================================
	# CRER la FENTRE de la CONSOLE
	# ==============================
	local win_top_bar = 30             # Measures obtainued from window.lua 
	local win_bot_bar = 10             # Measures obtainued from screenshots
	local editH = consoleFontSize + 4  # Measures obtainued from screenshots
	local margin = 5
	local spacer = 10
	
	local cpl_win_loc = Prefs.GetFromCurrentProfile( 'console_window' )
    local cpl_Top = cpl_win_loc.top or 10
    local cpl_Left = cpl_win_loc.left or 10 
    local cpl_H = win_top_bar + consH + spacer + editH + spacer + win_bot_bar # Heights from Top to Bottom
    local cpl_W = spacer + consW + spacer + toolPW + spacer + batchW + spacer + menuPW
    local cpl_Bottom = cpl_Top + cpl_H
    local cpl_Right  = cpl_Left + cpl_W
	
    local location = { Top = cpl_Top, Left = cpl_Left, Bottom = cpl_Bottom , Right = cpl_Right }
	local windowName = myConSplash  --	local windowName = FilteredLOC('<LOC _Console>Console')
    dialog = Window( mainFrame, windowName, nil, nil, true, false, false, 'console_window', location ) # RESIZABLE 
    #dialog = Window( mainFrame, windowName, nil, nil, true, true, false, 'console_window', location ) # SIZE LOCKED
    dialog.Depth:Set(UIUtil.consoleDepth)
    dialog:SetMinimumResize( cpl_W, cpl_H )
	#dialog:SetSizeLock(true)          # Fonctionnel avec mon patch aWindowLua.scd !
	#if dialog:IsSizeLocked()  then    # Fonctionnel avec mon patch aWindowLua.scd !
	#	LOG(" IS SIZE LOCKED = TRUE")
	#end
	
	Tooltip.AddButtonTooltip(dialog._configBtn, 'consplus_config')
	Tooltip.AddButtonTooltip(dialog._closeBtn, 'consplus_close')
	
    local clientGrp = dialog:GetClientGroup()
	
	# PANELS DEFINITION	
    clientGrp.conPanel = Group( clientGrp, "conPanel" )
	conPan = clientGrp.conPanel
    LayoutHelpers.AtLeftTopIn( conPan, clientGrp, margin, margin )
    conPan.Width:Set( consW )
    conPan.Height:Set( consH )
	
	clientGrp.toolPanel = Group( clientGrp, "toolPanel" )
	toolPan = clientGrp.toolPanel
    LayoutHelpers.RightOf( toolPan, conPan )
    toolPan.Width:Set( toolPW )
    toolPan.Height:Set( consH )
	
	clientGrp.batPanel = Group( clientGrp, "batPanel" )
	batPan = clientGrp.batPanel
    LayoutHelpers.RightOf( batPan, toolPan )
    batPan.Width:Set( batchW )
    batPan.Height:Set( consH )
	
	clientGrp.menuPanel = Group( clientGrp, "menuPanel" )
	menuPan = clientGrp.menuPanel
    LayoutHelpers.RightOf( menuPan, batPan )
    menuPan.Width:Set( menuPW )
    menuPan.Height:Set( consH )
	
	# ==========================================================================
	# CONSOLE PANEL
	
	# BOITE de SAISIE CONSOLE
    conPan.editCon = Edit( conPan )
    conPan.editCon.Left:Set(function() return conPan.Left() + spacer end)
    conPan.editCon.Right:Set(function() return conPan.Right() - 38 end)
    conPan.editCon.Bottom:Set(function() return conPan.Bottom() - spacer end)
    conPan.editCon:SetForegroundColor(UIUtil.consoleFGColor())
    conPan.editCon:SetBackgroundColor('ff333333')
    conPan.editCon:SetHighlightForegroundColor("black")
    conPan.editCon:SetHighlightBackgroundColor(UIUtil.consoleTextBGColor())
    conPan.editCon:SetFont(consoleFontName, consoleFontSize)
    conPan.editCon.Height:Set(function() return math.floor(conPan.editCon:GetFontHeight()) end)
	
	# AFFICHAGE de la CONSOLE
	conPan.consoleOutput = ItemList( conPan )
    LayoutHelpers.Above( conPan.consoleOutput, conPan.editCon, spacer )
    conPan.consoleOutput.Top:Set(function() return conPan.Top() + margin end)
    conPan.consoleOutput.Right:Set( conPan.editCon.Right )
    conPan.consoleOutput:SetColors(UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor(), UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor()) -- we don't really want selection here so don't differentiate colors
    conPan.consoleOutput:SetFont(consoleFontName, consoleFontSize)
	
	# ASCENCEUR pour AFFICHAGE de la CONSOLE
    UIUtil.CreateVertScrollbarFor( conPan.consoleOutput )
	
	# ==========================================================================
	# TOOLS PANEL
	
	# BOUTON ADD CMDE !
    toolPan.addBtn = UIUtil.CreateButtonStd( toolPan, '/widgets/tiny', "+", 18 )
    LayoutHelpers.AtLeftTopIn( toolPan.addBtn, toolPan, margin, margin )
	Tooltip.AddButtonTooltip( toolPan.addBtn, 'consplus_add' )
	
	# BOUTON DEL CMDE !
    toolPan.delBtn = UIUtil.CreateButtonStd( toolPan, '/widgets/tiny', "-", 14 )
    LayoutHelpers.Below( toolPan.delBtn, toolPan.addBtn, margin )
	Tooltip.AddButtonTooltip( toolPan.delBtn, 'consplus_del' )
	
	# BOUTON CLEAR EDIT !
    toolPan.clearBtn = UIUtil.CreateButtonStd( toolPan, '/widgets/tiny', "x", 14 )
    LayoutHelpers.Below( toolPan.clearBtn, toolPan.delBtn, margin )
	Tooltip.AddButtonTooltip( toolPan.clearBtn, 'consplus_clear' )
	
	# BOUTON AIDE !
    toolPan.aideBtn = UIUtil.CreateButtonStd( toolPan, '/widgets/tiny', "?", 14 )
    LayoutHelpers.Below( toolPan.aideBtn, toolPan.clearBtn, margin ) 
	Tooltip.AddButtonTooltip( toolPan.aideBtn, 'consplus_aide' )
	
	
	# ==========================================================================
	# BATCHER PANEL
	
	# BOITE de SAISIE BATCHER
    batPan.editBat = Edit( batPan )
    batPan.editBat.Left:Set(function() return batPan.Left() + spacer end)
    batPan.editBat.Right:Set(function() return batPan.Right() - 38 end)
    batPan.editBat.Bottom:Set(function() return batPan.Bottom() - spacer end)
    batPan.editBat:SetForegroundColor(UIUtil.consoleFGColor())
    batPan.editBat:SetBackgroundColor('ff333333')
    batPan.editBat:SetHighlightForegroundColor("black")
    batPan.editBat:SetHighlightBackgroundColor(UIUtil.consoleTextBGColor())
    batPan.editBat:SetFont(consoleFontName, consoleFontSize)
    batPan.editBat.Height:Set(function() return math.floor(batPan.editBat:GetFontHeight()) end)
	
	# AFFICHAGE du BATCHER
	batPan.batcherOutput = ItemList( batPan )  # TRANSFORMATION EN COMBO SPECIAL DE MON CRU
    LayoutHelpers.Above( batPan.batcherOutput, batPan.editBat, spacer )
    batPan.batcherOutput.Top:Set(function() return batPan.Top() + (spacer * 3) end)
    batPan.batcherOutput.Right:Set( batPan.editBat.Right )
    batPan.batcherOutput:SetColors(UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor(), UIUtil.consoleFGColor(), UIUtil.consoleTextBGColor()) -- we don't really want selection here so don't differentiate colors
    batPan.batcherOutput:SetFont(consoleFontName, consoleFontSize)
	
	# ASCENCEUR pour AFFICHAGE du BATCHER
    UIUtil.CreateVertScrollbarFor( batPan.batcherOutput )
	
	# AFFICHAGE du BATCHER dans DnDcombo (COMBO SPECIAL avec DRAG & DROP)
	local DnDcombo = import( MyModPath .. '/hook/lua/ui/controls/DnDcombo.lua' ).DnDcombo
	batPan.batcherSpew = DnDcombo( batPan )
    LayoutHelpers.Above( batPan.batcherSpew, batPan.batcherOutput, spacer )
    batPan.batcherSpew.Top:Set(function() return batPan.Top() + margin end)
    batPan.batcherSpew.Right:Set( batPan.batcherOutput.Right )
	
	
	# ==========================================================================
	# MENU PANEL
	
	# BOUTON NOUVEAU BATCH !
    menuPan.newbBtn = UIUtil.CreateButtonStd( menuPan, '/widgets/tiny', "<LOC _newbBtn>New", 10 )
    LayoutHelpers.AtLeftTopIn( menuPan.newbBtn, menuPan, margin, margin )
	Tooltip.AddButtonTooltip( menuPan.newbBtn, 'consplus_newb' )
	
	# BOUTON CHARGER BATCH !
    menuPan.loadBtn = UIUtil.CreateButtonStd( menuPan, '/widgets/tiny', "<LOC _loadBtn>Load", 10 )
    LayoutHelpers.Below( menuPan.loadBtn, menuPan.newbBtn, margin ) #  DROITE DE editBat, EN DESSOUS du Bouton New
	Tooltip.AddButtonTooltip( menuPan.loadBtn, 'consplus_load' )
	
	# BOUTON SAUVEGARDER BATCH !
    menuPan.saveBtn = UIUtil.CreateButtonStd( menuPan, '/widgets/tiny', "<LOC _saveBtn>Save", 10 )
    LayoutHelpers.Below( menuPan.saveBtn, menuPan.loadBtn, margin ) #  DROITE DE editBat, EN DESSOUS du Bouton Load
	Tooltip.AddButtonTooltip( menuPan.saveBtn, 'consplus_save' )
	
	# BOUTON EXECUTER BATCH !
    menuPan.runBtn = UIUtil.CreateButtonStd( menuPan, '/widgets/tiny', "<LOC _runBtn>Run", 10 )
    LayoutHelpers.Below( menuPan.runBtn, menuPan.saveBtn, margin ) #  DROITE DE editBat, EN DESSOUS du Bouton Save
	Tooltip.AddButtonTooltip( menuPan.runBtn, 'consplus_run' )
	
	
	# ==========================================================================
	
	muteOutputHandler = AddMuteOutputHandler()
	
	# ENLEVER LES MARQUES DE COMMENTAIRE DEVANT muteOutputHandler ET DEVANT RemoveMuteOutputHandler
	# PUIS PLACER ICI TOUTES COMMANDES CONSOLE  EXECUTER en MODE << MUET >>
	# REMOVE COMMMENT MARKS PRECEEDING muteOutputHandler AND RemoveMuteOutputHandler
	# THEN DROP THERE CONSOLE COMMANDS TO BE EXECUTED IN << MUTE >> MODE
	ConExecute( 'con_echo'..' '.." THIS IS A TEST THAT SHOULD NOT SHOW UP AT ALL" )
	
	RemoveMuteOutputHandler()
	
	# ==========================================================================
	
	
	function AddOutputHandler()
		-- set up output control to recieve console spew
		return AddConsoleOutputReciever( function(text)
			table.insert(recupText, text)    # BIEN GRER LE TAMPON recupText SINON GARE AU DEBORDEMENT !
			
			conPan.consoleOutput:AddItem(text)
			local itemCount = conPan.consoleOutput:GetItemCount()
			
			if ( itemCount > itemBufferSize ) then  -- number of items should be = number of commands (enter Help command as a good example)
				conPan.consoleOutput:DeleteItem(0)
			end
			conPan.consoleOutput:SetSelection(itemCount - 1)
			conPan.consoleOutput:ScrollToBottom()
		end)
	end
	
	outputHandler = AddOutputHandler()	
	
	function RemoveOutputHandler()
		if outputHandler then
			RemoveConsoleOutputReciever( outputHandler )
		end
	end
	
	# ==========================================================================
	# Effacer Affichage de la CONSOLE 
	
	function ClearConsoleDisplay()
		if conPan.consoleOutput then
			conPan.consoleOutput:DeleteAllItems()
			conPan.consoleOutput:Empty()
			ConExecute( 'con_echo'..' '..myConSplash )
			hideMyConSplash = true
		end
	end
	
	# ==========================================================================
		
    dialog.OnConfigClick = function( self )
        ConfigWindow( dialog )
    end
    -- if this gets destroyed we need to unregister and destroy the output handler
    dialog.OnDestroy = function( self )
		RemoveConsoleOutputReciever( outputHandler )
    end
	
    -- HANDLE EDIT CONTROL
    local conFuncsList = false
    local raiseConFuncList = true
	
    conPan.editCon.OnTextChanged = function(self, newText, oldText)
        if raiseConFuncList then
			if conFuncsList then
				conFuncsList:Destroy()
				conFuncsList = false
			end
			
            local conMatches = ConTextMatches( newText )
			
			local matches = myConTextMatches( conMatches, newText )   ## Fusion de ma Liste de Commandes

            local numMatches = table.getn( matches )
			
            if ( numMatches > 0 ) then
                conFuncsList = ItemList( conPan.consoleOutput )  ### <== INTERCEPTER LA CONSOLE ICI ?!?
                conFuncsList:SetFont( consoleFontName, consoleFontSize )
                LayoutHelpers.Above( conFuncsList, conPan.editCon )
                conFuncsList.Right:Set( function() return conPan.editCon.Right() - 32 end )
                conFuncsList.Height:Set( function()
                    return math.min(conPan.consoleOutput.Height(), conFuncsList:GetRowHeight() * numMatches)
                end )
				
                for i,v in matches do
					conFuncsList:AddItem( v )
                end
				
                if conFuncsList:NeedsScrollBar() then
                    UIUtil.CreateVertScrollbarFor( conFuncsList )
                end
                
                conFuncsList:SetSelection( conFuncsList:GetItemCount() - 1 ) -- SI Iten Count = 0 ALORS ERREUR
                conFuncsList:ScrollToBottom()
				
                conFuncsList.OnClick = function( self, row, event )
					conFuncsList:SetSelection( row )  -- REPRISE INDISPENSABLE DU CODE ORIGINAL DE itemlist.lua EN PREVISION DE MODIFS
                end
				
                conFuncsList.OnDoubleClick = function( self, row, event )	-- SUPPRESSION DE conFuncsList FAITE AU DBUT DE OnTextChanged
					conFuncsList:OnClick( row )  -- REPRISE INDISPENSABLE DU CODE ORIGINAL DE itemlist.lua
					local texte = conFuncsList:GetItem( row )
					if event.Modifiers.Right then    -- Item SLECTIONN DPLAC DANS editBat 
						batPan.editBat:SetText( texte )
						batPan.editBat:AcquireFocus()
						conPan.editCon:SetText("") -- NETTOYER editCon CAR Item SLECTIONN EST UTILIS DANS editBat
					elseif event.Modifiers.Left then    -- Item SLECTIONN DPLAC DANS editCon
						conPan.editCon:SetText( texte )
						conPan.editCon:AcquireFocus()
						batPan.editBat:SetText("") -- NETTOYER editBat CAR Item SLECTIONN EST UTILIS DANS editCon
					end
				end
				
            end
        end
    end
	
	############################################################################
	
    ExecuterCommande = function( text )    # COMMANDE DJ EXECUTE QUAND OnEnterPressed EST SIGNAL !
		
		local cmdLine = ConsolePlus.Interpreter( text )	# GRER LE FILTRAGE DU TEXTE SINON GARE AUX FUITES ! :P
		if not cmdLine or (cmdLine == nil) then
			WARN('### MANIMAL DEBUG:  console.lua  -> ExecuterCommande has no cmdLine to work with ! ###')
		end
		
		if (string.len(cmdLine.ligne) > 0) then
			if (string.lower(cmdLine.ligne) == string.lower('CON_ClearDisplay') ) then
				#  FAIRE: TROUVER AUTRE SOLUTION (appel depuis Interpreter ?) # NE SE COMPORTAIT PAS COMME PRVU HORS DE CE BLOC
				ClearConsoleDisplay()    # CLEAR CONSOLE SCREEN
				InsertConCommandInQueue(cmdLine.ligne)
			end
			if cmdLine.muteCon then    # MODE <<SILENCIEUX>>
				# SEMBLE TRE INOPERANT -> #ConsoleEcho.showEchoOnConsole = false  # Fixer TAT Console Echo
				
				RemoveOutputHandler()                            # FERMER RECEPTEUR <!>
				if (string.len(cmdLine.substLigne) == 0) then
					ConExecuteSave( cmdLine.ligne )
				else
					ConExecuteSave( cmdLine.substLigne )
					InsertConCommandInQueue(cmdLine.ligne)
				end
				outputHandler = AddOutputHandler()               # OUVRIR RECEPTEUR <!>
				
				# SEMBLE TRE INOPERANT -> #ConsoleEcho.showEchoOnConsole = true  # Fixer TAT Console Echo
			else    # MODE <<NORMAL>>
				if (string.len(cmdLine.substLigne) == 0) then
					ConExecuteSave(cmdLine.ligne)                 --# EXECUTER COMMANDE ORIGINALE
					InsertConCommandInQueue(cmdLine.ligne)
				else
					ConExecuteSave( cmdLine.substLigne )          --# EXECUTER COMMANDE SUBSTITUTION
					InsertConCommandInQueue(cmdLine.ligne)
				end
			end
		end
		if string.len(cmdLine.aide) > 0 then
			ConExecute(('con_echo'..' '..cmdLine.aide))
		end
		cmdLine = {}
    end
	
	############################################################################
	
	
    conPan.editCon.OnEnterPressed = function(self, text)    # COMMANDE DJ EXECUTE QUAND OnEnterPressed EST SIGNAL !
		ExecuterCommande( text ) 
    end
	
	
    conPan.editCon.OnNonTextKeyPressed = function(self, keycode)
        local function ChangeConFuncSelection(direction)
            local selection = math.max(math.min(conFuncsList:GetSelection() + direction, conFuncsList:GetItemCount() - 1), 0)  -- SI Item Count = 0 ALORS ERREUR !
            conFuncsList:SetSelection(selection)
            raiseConFuncList = false
            conPan.editCon:SetText(conFuncsList:GetItem(selection))
            raiseConFuncList = true
        end
		
		if keycode == UIUtil.VK_UP then
            if conFuncsList then
                ChangeConFuncSelection(-1)
            else
                -- store off the current text if this is the first press
                local commandDequeSize = table.getn(commandDeque)
                if commandDequeSize > 0 then
                    if currentCommandDequeIndex == commandDequeSize then currentText = conPan.editCon:GetText() end
                    conPan.editCon:SetText(commandDeque[currentCommandDequeIndex])
                    currentCommandDequeIndex = currentCommandDequeIndex - 1
                    if currentCommandDequeIndex <= 0 then currentCommandDequeIndex = 1 end
                end
            end
        elseif keycode == UIUtil.VK_DOWN then
            if conFuncsList then
                ChangeConFuncSelection(1)
            else
                currentCommandDequeIndex = currentCommandDequeIndex + 1
                if currentCommandDequeIndex > table.getn(commandDeque) then
                    currentCommandDequeIndex = table.getn(commandDeque)
                    conPan.editCon:SetText(currentText)
                else
                    conPan.editCon:SetText(commandDeque[currentCommandDequeIndex])
                end
            end
        end
    end
	
    conPan.editCon.OnCharPressed = function(self, charcode)
        if charcode == 96 then        -- close console on tilde key (apostrophe, or ascii 96)
            conPan.editCon:AbandonKeyboardFocus()
            dialog:Hide()
            return true
        elseif charcode == UIUtil.VK_TAB then
            if conFuncsList then
                conPan.editCon:SetText(conFuncsList:GetItem(conFuncsList:GetSelection()))
                return true
            else
                return false
            end
        else
            return false
        end
    end
	
	# ==========================================================================
	
	batch.UpdateTooltips = function()
		# AIDE CONEXTUELLE sur les COMMANDES AFFICHES dans le BATCHER
		local myTooltipList = GetCommandTooltipListFromBatch( monBatch )
		# AFFICHAGE des Tooltips de staticTitle et de itemList !
		TooltipPlus.AddComboTooltip( batPan.batcherSpew, "consplus_batchddn", myTooltipList )  # Uses my Special Dynamic Tooltip Info
	end
	
	batch.OnContentAltered = function()  # For updating stuff
		batch.UpdateTooltips()
	end
	
	
	batch.OnAdd = function()  # For updating stuff
	end
	
    toolPan.addBtn.OnClick = function( button )  # AJOUTE TEXTE conEdit  batEdit, DOUBLE CLIC LE FAIT DJ AUSSI BIEN
		if conFuncsList then 
			local itemCount = conFuncsList:GetItemCount() - 1 # WHAT IF count-1 = 0 ??? GPG Devs WEIRDNESS IN ORDER TO MATCH C++ ARRAYS ?
			if ( itemCount >= 0 ) then
				local currentText = conFuncsList:GetItem(conFuncsList:GetSelection()) # CLONER la SELECTION de CONSOLE
				derniereEntree = currentText
				batPan.editBat:SetText( derniereEntree )    # LAISSER POUR MODIFS EVENTUELLES
				batch.OnAdd()
			end
		end
    end
	
	
	batch.OnDel = function()  # For updating stuff
		batPan.batcherSpew:ClearItems()                 # EFFACEMENT TOTAL
		batPan.batcherSpew:AddItems( monBatch )         # CHARGEMENT TOTAL
		batch.OnContentAltered()
	end
	
    toolPan.delBtn.OnClick = function( button )  # SUPPRIME TEXTE SELECTIONN DANS BATCH EDIT
		local itemCount = ( batPan.batcherOutput:GetItemCount() - 1 ) or 0
		local selection = math.max(math.min(batPan.batcherOutput:GetSelection(), itemCount), 0)
		if (selection >= 0) then
			local itemTxt = batPan.batcherOutput:GetItem(selection) or "!?!"
			table.remove( monBatch, ( selection + 1 ) )     # EFFACEMENT SELECTION COURANTE (+1) dans monBatch
			batPan.batcherOutput:DeleteItem(selection)      # EFFACEMENT SELECTION COURANTE
			itemCount = ( batPan.batcherOutput:GetItemCount() - 1 ) or 0
			batPan.batcherOutput:SetSelection(itemCount)    # SELECTION DERNIER ITEM APRES EFFACEMENT D UN ITEM
			batPan.batcherOutput:ScrollToBottom()
			derniereEntree = ""
			batPan.editBat:SetText( derniereEntree )        # REINITIALISER le TEXTE de la BOITE de SAISIE
			batch.OnDel()
		end
	end
	
	
    toolPan.clearBtn.OnClick = function( button )
		derniereEntree = ""
		batPan.editBat:SetText( derniereEntree ) # EFFACER le TEXTE de la BOITE de SAISIE ( RZ editBat !!! )
	end
	
    toolPan.aideBtn.OnClick = function( button )
		ConsolePlusHelp.DisplayConPlusHelpWindow()
    end
	
	
	# ==========================================================================
	
	# MISE  JOUR LISTE POP-UP batPan.batcherSpew -> batPan.batcherOutput
	
	batch.OnDragDropContent = function()
		batPan.batcherSpew:ClearItems()                 # EFFACEMENT TOTAL
		batPan.batcherSpew:AddItems( monBatch )         # CHARGEMENT TOTAL
		batch.OnContentAltered()
	end
	
	batPan.batcherSpew.OnDropItem = function( self )
		if not( batPan.batcherSpew:isItemDropped() ) then
			return
		end
		batPan.batcherOutput:DeleteAllItems()
		batPan.batcherOutput:Empty()
		monBatch = {}
		monBatch = batPan.batcherSpew:GetVisibleItems()  # DEVRAIT FOURNIR JUSTE LES LMENTS VISIBLES !!!
		for i, cmnde in monBatch do
			batPan.batcherOutput:AddItem( cmnde )
			local itemCount = ( batPan.batcherOutput:GetItemCount() - 1 ) or 0 # Compte de 0 (1er elt)  N elts 
			if ( itemCount > itemBufferSize ) then  -- number of items should be = maximum number of commands of the batch file
				batPan.batcherOutput:DeleteItem(0)
			else
				derniereEntree = cmnde
			end
			batPan.batcherOutput:SetSelection( itemCount )
			batPan.batcherOutput:ScrollToBottom()
		end
		batch.OnDragDropContent()
	end
	
	batPan.batcherSpew.OnClick = function( self, index, text )
		if text and ( type( text ) == 'string' ) and ( string.len( text ) > 0 ) then
			derniereEntree = text
			batPan.editBat:SetText( derniereEntree )    # LAISSER POUR MODIFS EVENTUELLES
			batch.OnAdd()
		end
	end
	
	# ==========================================================================
	
	
	batch.OnEnterPressed = function()  # For updating stuff
		batPan.batcherSpew:ClearItems()                     # EFFACEMENT TOTAL
		batPan.batcherSpew:AddItems( monBatch )             # CHARGEMENT TOTAL
		batch.OnContentAltered()
	end
	
    batPan.editBat.OnEnterPressed = function( self, text )  # COMMANDE DJ EXECUTE QUAND OnEnterPressed EST SIGNAL !
		batPan.batcherOutput:AddItem( text )
		local itemCount = ( batPan.batcherOutput:GetItemCount() - 1 ) or 0
		if ( itemCount > itemBufferSize ) then  -- number of items should be = maximum number of commands of the batch file
			batPan.batcherOutput:DeleteItem(0)
		else
			table.insert( monBatch, text )
		end
		batPan.batcherOutput:SetSelection(itemCount)
		batPan.batcherOutput:ScrollToBottom()
		batch.OnEnterPressed()
	end
	
    batPan.editBat.OnNonTextKeyPressed = function(self, keycode)
        local function ChangeBatFuncSelection(direction)
			local itemCount = ( batPan.batcherOutput:GetItemCount() - 1 ) or 0
            local selection = math.max(math.min(batPan.batcherOutput:GetSelection() + direction, itemCount), 0)
            batPan.batcherOutput:SetSelection(selection)
            batPan.editBat:SetText(batPan.batcherOutput:GetItem(selection))
        end
		
		local itemCount = ( batPan.batcherOutput:GetItemCount() - 1 ) or 0
		if keycode == UIUtil.VK_UP then
            if ( itemCount > 0 ) then
                ChangeBatFuncSelection(-1)
            end
        elseif keycode == UIUtil.VK_DOWN then
            if ( itemCount >= 0 ) then
                ChangeBatFuncSelection(1)
            end
        end
		
    end
	
    batPan.editBat.OnCharPressed = function(self, charcode)
        if charcode == 96 then   -- close console on tilde key (apostrophe, or ascii 96)
            batPan.editCon:AbandonKeyboardFocus()
            dialog:Hide()
            return true
        elseif charcode == UIUtil.VK_TAB then
            if batPan.batcherOutput then
                batPan.editBat:SetText(batPan.batcherOutput:GetItem(batPan.batcherOutput:GetSelection()))
                return true
            else
                return false
            end
        else
            return false
        end
    end
	
	
	# ==========================================================================
	
	batch.OnNew = function()
		batPan.batcherSpew:ClearItems()
		batch.OnContentAltered()
	end
	
    menuPan.newbBtn.OnClick = function( button )
		monBatch = nil
		monBatch = { }
		batPan.batcherOutput:DeleteAllItems()
		batPan.batcherOutput:Empty()
		derniereEntree = ""
		batchIsLoaded = false
		batch.OnNew()
    end
	
	
	batch.OnLoad = function()
		batPan.batcherSpew:ClearItems()                    # EFFACEMENT TOTAL
		batPan.batcherSpew:AddItems( monBatch )            # CHARGEMENT TOTAL
		batch.OnContentAltered()
	end
	
    menuPan.loadBtn.OnClick = function(button)
		# A BATCH IS NOT MANDATORY, PLAYER COULD WANT TO GET AN EMPTY BATCH AT GAME START !
		# AN EMPTY BATCH WOULD RESET THE BATCH DISPLAY IN CONSOLE BY THE WAY, SO KEEP IT LIKE THAT.
		menuPan.newbBtn.OnClick()
		# CHARGER Batch  partir du Profil
		monBatch = Prefs.GetFromCurrentProfile( 'ConsolePlus_command_batch' ) or false
		if monBatch and ( table.getn( monBatch ) > 0 ) then
			for i, cmnde in monBatch do
				batPan.batcherOutput:AddItem( cmnde )
				local itemCount = ( batPan.batcherOutput:GetItemCount() - 1 ) or 0 # Compte de 0 (1er elt)  N elts 
				if ( itemCount > itemBufferSize ) then  -- number of items should be = maximum number of commands of the batch file
					batPan.batcherOutput:DeleteItem(0)
				else
					derniereEntree = cmnde
				end
				batPan.batcherOutput:SetSelection( itemCount )
				batPan.batcherOutput:ScrollToBottom()
			end
			if ( table.getn( monBatch ) > 0 ) then
				batchIsLoaded = true  # NE PAS SIGNALER SI BATCH !!!
				batch.OnLoad()
				local commande = 'Echo '..LOC('<LOC batch_loaded>Batch is Loaded !')
				ExecuterCommande( commande )
			end
		end
    end
	
	if not batchIsLoaded then
		menuPan.loadBtn.OnClick()
    end
	
	batch.OnSave = function()
	end
	
    menuPan.saveBtn.OnClick = function(button)
		# A BATCH IS NOT MANDATORY, PLAYER COULD WANT TO GET AN EMPTY BATCH AT GAME START ! 
		# AN EMPTY BATCH WOULD RESET THE BATCH IN PROFILE BY THE WAY, SO KEEP IT LIKE THAT.
		# SAUVER Batch dans le Profil
		if monBatch and ( monBatch ~= nil ) and ( table.getn( monBatch ) > 0 ) then
			Prefs.SetToCurrentProfile( 'ConsolePlus_command_batch', monBatch )
			#ConsolePlusUtils.SaveBatchToPreferences( monBatch )  # Sauvegarde Batch dans Game.Prefs Direct-to-Disk ( voir note dans ConsolePlusUtils )
			batch.OnSave()
			local commande = 'Echo '..LOC('<LOC batch_saved>Batch is Saved !')
			ExecuterCommande( commande )
		end
	end
	
	
	batch.OnRun = function()
	end
	
    menuPan.runBtn.OnClick = function(button)
		if batchIsLoaded then
			if monBatch and (table.getn(monBatch) > 0) then
				for ligne, commande in monBatch do
					LOG('MANIMAL DEBUG:  console.lua  -> RUN : Current Command = '..(commande or "PROBLEME"))
					if (type(commande) == 'string') and (string.len(commande) > 0) then
						# SKIP LINES THAT ARE COMMENTED OUT ! #  FAIRE: FILTRER INTGRALEMENT la ligne
						if ( string.sub( commande, 1, 1 ) ~= '#') or ( string.sub( commande, 1, 2 ) ~= '--') then 
							ExecuterCommande( commande )
						end
					else
						WARN('MANIMAL DEBUG: console.lua  -> Error: Attempt to use '..tostring(type(commande))..' as a console command at line '..tostring(ligne)..' (a string was expected). Skipping Erroneous Command Line...')
					end
				end
				batch.OnRun()
				local commande = 'Echo '..LOC('<LOC _done>done !')
				ExecuterCommande( commande )
			end
		end
    end
	
	# ==========================================================================
	
	
    -- override Show behavior to acquire keyboard focus
    dialog.Show = function(self)
		if not hideMyConSplash then
			ConExecute( 'con_echo'..' '..myConSplash )
			hideMyConSplash = true
		end
        conPan.editCon:AcquireFocus()
        Control.Show(self)
    end
	
    dialog.Hide = function(self)
        if window then
            window:Destroy()
            window = false
        end
        Control.Hide(self)
    end
	
    dialog.OnClose = function(self)
        self:Hide()
    end
	
    local tempalpha = Prefs.GetFromCurrentProfile('console_alpha') or 1
    dialog:SetAlpha(tempalpha, true)
	
    return dialog
end



################################################################################

