--[[################################################################################
    # File      : /schook/lua/system/mesUtiles.lua                                 #
    # Author    : Manimal                                                          #
    # Version   : 04 fevrier 2009                                                  #
    # Revision  : 20 fevrier 2009                                                  #
    #                                                                              #
    # Summary   : Utilites diverses pour Mods de Manimal                           #
    # Copyright : CopyLeft 2008 Manimal.                                           #
    ################################################################################]]--

--################################################################################
--#  AJOUTS FONCTIONS PERSO
--################################################################################

--[[======================================================================================================
  #  Ajout Automatique de TABS pour Affichage Format du Contenu d'un Table  #
--====================================================================================================== ]]--

function AddTabs( n )
	local tab = ""
	if n > 0 then
		for i=1, n do
			tab = tab .. "\t"
		end
	end
	return tab
end


--[[======================================================================================================
  #  Calcul de Nombre de DIGITS (string) pour Affichage Format du Contenu d'un Table  #
--====================================================================================================== ]]--
 
function StrEvalNbDigits( n )
	return string.len( tostring(n) )
end


--[[======================================================================================================
  #  Calcul de Nombre de DIGITS (number) pour Affichage Format du Contenu d'un Table  #
--====================================================================================================== ]]--
 
function NumEvalNbDigits( n )
	if type(n) ~= 'number' then
		WARN( "MANIMAL DEBUG:  Error in NumEvalNbDigits: a number was expected, got " .. type(n) )
		return n
	end
	return tonumber( StrEvalNbDigits(n) )
end


--[[======================================================================================================
--#  Affichage du Contenu d'un Table sous forme de Texte Format  #
--====================================================================================================== ]]--

local niv = 0

function table.print( tabl )
	if not ( tabl and (tabl ~= nil) and (type(tabl) == 'table') ) then
		WARN( "MANIMAL DEBUG:  Error in table.print: a table was expected" )
		return tabl
	end
	
	local tLen = table.getn(tabl)
	LOG( AddTabs(niv) .. "table = {" )
	niv = niv + 1
	for k, v in pairs( tabl ) do    --# AFFICHE LA TABLE APPARAMENT DESORDONNEE	--for k, v in tabl do    --# AFFICHE LA TABLE QUASIMENT ORDONNEE !
		if type(v) == 'table' then
			table.print( v )
		else
			local sep = ''
			if type(v) == 'string' then
				sep = '\"'
			end
			if type(k)== 'number' then
				local nDigit = StrEvalNbDigits(tLen)
				LOG( AddTabs(niv) .. "[" .. string.format( '%' ..nDigit.. 'd', k ) .. "] = " .. ( (sep .. tostring(v) .. sep .. ',') or "<<NEANT>>") )
			else
				LOG( AddTabs(niv) .. "[" .. tostring(k) .. "] = " .. ( (sep .. tostring(v) .. sep .. ',') or "<<NEANT>>") )
			end
		end
	end
	niv = niv - 1
	LOG( AddTabs(niv) .. "}," )
	if  (niv == 0)  then  LOG( "" )  end
end


--################################################################################


